import {Complex} from './type.js'
import {Dependencies, OpType} from '../interfaces/type.js'

export const equal =
   <T>(dep: Dependencies<'equal', T>): OpType<'equal', Complex<T>> =>
   (w, z) => dep.equal(w.re, z.re) && dep.equal(w.im, z.im)
